// Include servo lib
#include <Servo.h> 
 
Servo myservo;  // create servo object to control a servo 
 
const int POTpin = A0;  // analog pin used to connect the potentiometer
const int ServoPin = 9;
const int SetButton = 2;

int POTval;    // variable to read the value from the analog pin 
int Smax = 180;// the Servo Max angle

// DO once 
void setup() 
{ 
  myservo.attach(ServoPin,300,2400);  // attaches the servo on pin 9 to the servo object 
} 

// Do many 
void loop() 
{ 
  POTval = analogRead(POTpin);  // reads the value of the potentiometer (value between 0 and 1023)
  POTval = map(POTval, 0, 1023, 0, 180);  // scale it to use it with the servo (value between 0 and 180) 
  if(POTval > Smax)
    {
      POTval = Smax; // check to see if we are beyond our max
    }
  myservo.write(POTval);                  // sets the servo position according to the scaled value 
  delay(15);                           // waits for the servo to get there 
  
  // Was Calibration button pressed
  if(digitalRead(SetButton))
    {
      ServoCal();
    }
} 


// My Function to calivrate the servo to 90
void ServoCal()
{
  Smax = analogRead(POTpin); // Grab the current POT position
  Smax = map(Smax, 0, 1023, 0, 180); // Scle it to the max angles 0 to 180
  return;
}  
